/*
 * AUTOGENERATED - DO NOT EDIT
 *
 * This file is generated from input-method-unstable-v1.xml by mir_wayland_generator
 */

#include "input-method-unstable-v1_wrapper.h"

#include <boost/exception/diagnostic_information.hpp>
#include <wayland-server-core.h>

#include "mir/log.h"
#include "mir/wayland/protocol_error.h"
#include "mir/wayland/client.h"

namespace mir
{
namespace wayland
{
extern struct wl_interface const wl_keyboard_interface_data;
extern struct wl_interface const wl_output_interface_data;
extern struct wl_interface const wl_surface_interface_data;
extern struct wl_interface const zwp_input_method_context_v1_interface_data;
extern struct wl_interface const zwp_input_method_v1_interface_data;
extern struct wl_interface const zwp_input_panel_surface_v1_interface_data;
extern struct wl_interface const zwp_input_panel_v1_interface_data;
}
}

namespace mw = mir::wayland;

namespace
{
struct wl_interface const* all_null_types [] {
    nullptr,
    nullptr,
    nullptr,
    nullptr,
    nullptr,
    nullptr};
}

// InputMethodContextV1

struct mw::InputMethodContextV1::Thunks
{
    static int const supported_version;

    static void destroy_thunk(struct wl_client* client, struct wl_resource* resource)
    {
        try
        {
            wl_resource_destroy(resource);
        }
        catch(ProtocolError const& err)
        {
            wl_resource_post_error(err.resource(), err.code(), "%s", err.message());
        }
        catch(...)
        {
            internal_error_processing_request(client, "InputMethodContextV1::destroy()");
        }
    }

    static void commit_string_thunk(struct wl_client* client, struct wl_resource* resource, uint32_t serial, char const* text)
    {
        try
        {
            auto me = static_cast<InputMethodContextV1*>(wl_resource_get_user_data(resource));
            me->commit_string(serial, text);
        }
        catch(ProtocolError const& err)
        {
            wl_resource_post_error(err.resource(), err.code(), "%s", err.message());
        }
        catch(...)
        {
            internal_error_processing_request(client, "InputMethodContextV1::commit_string()");
        }
    }

    static void preedit_string_thunk(struct wl_client* client, struct wl_resource* resource, uint32_t serial, char const* text, char const* commit)
    {
        try
        {
            auto me = static_cast<InputMethodContextV1*>(wl_resource_get_user_data(resource));
            me->preedit_string(serial, text, commit);
        }
        catch(ProtocolError const& err)
        {
            wl_resource_post_error(err.resource(), err.code(), "%s", err.message());
        }
        catch(...)
        {
            internal_error_processing_request(client, "InputMethodContextV1::preedit_string()");
        }
    }

    static void preedit_styling_thunk(struct wl_client* client, struct wl_resource* resource, uint32_t index, uint32_t length, uint32_t style)
    {
        try
        {
            auto me = static_cast<InputMethodContextV1*>(wl_resource_get_user_data(resource));
            me->preedit_styling(index, length, style);
        }
        catch(ProtocolError const& err)
        {
            wl_resource_post_error(err.resource(), err.code(), "%s", err.message());
        }
        catch(...)
        {
            internal_error_processing_request(client, "InputMethodContextV1::preedit_styling()");
        }
    }

    static void preedit_cursor_thunk(struct wl_client* client, struct wl_resource* resource, int32_t index)
    {
        try
        {
            auto me = static_cast<InputMethodContextV1*>(wl_resource_get_user_data(resource));
            me->preedit_cursor(index);
        }
        catch(ProtocolError const& err)
        {
            wl_resource_post_error(err.resource(), err.code(), "%s", err.message());
        }
        catch(...)
        {
            internal_error_processing_request(client, "InputMethodContextV1::preedit_cursor()");
        }
    }

    static void delete_surrounding_text_thunk(struct wl_client* client, struct wl_resource* resource, int32_t index, uint32_t length)
    {
        try
        {
            auto me = static_cast<InputMethodContextV1*>(wl_resource_get_user_data(resource));
            me->delete_surrounding_text(index, length);
        }
        catch(ProtocolError const& err)
        {
            wl_resource_post_error(err.resource(), err.code(), "%s", err.message());
        }
        catch(...)
        {
            internal_error_processing_request(client, "InputMethodContextV1::delete_surrounding_text()");
        }
    }

    static void cursor_position_thunk(struct wl_client* client, struct wl_resource* resource, int32_t index, int32_t anchor)
    {
        try
        {
            auto me = static_cast<InputMethodContextV1*>(wl_resource_get_user_data(resource));
            me->cursor_position(index, anchor);
        }
        catch(ProtocolError const& err)
        {
            wl_resource_post_error(err.resource(), err.code(), "%s", err.message());
        }
        catch(...)
        {
            internal_error_processing_request(client, "InputMethodContextV1::cursor_position()");
        }
    }

    static void modifiers_map_thunk(struct wl_client* client, struct wl_resource* resource, struct wl_array* map)
    {
        try
        {
            auto me = static_cast<InputMethodContextV1*>(wl_resource_get_user_data(resource));
            me->modifiers_map(map);
        }
        catch(ProtocolError const& err)
        {
            wl_resource_post_error(err.resource(), err.code(), "%s", err.message());
        }
        catch(...)
        {
            internal_error_processing_request(client, "InputMethodContextV1::modifiers_map()");
        }
    }

    static void keysym_thunk(struct wl_client* client, struct wl_resource* resource, uint32_t serial, uint32_t time, uint32_t sym, uint32_t state, uint32_t modifiers)
    {
        try
        {
            auto me = static_cast<InputMethodContextV1*>(wl_resource_get_user_data(resource));
            me->keysym(serial, time, sym, state, modifiers);
        }
        catch(ProtocolError const& err)
        {
            wl_resource_post_error(err.resource(), err.code(), "%s", err.message());
        }
        catch(...)
        {
            internal_error_processing_request(client, "InputMethodContextV1::keysym()");
        }
    }

    static void grab_keyboard_thunk(struct wl_client* client, struct wl_resource* resource, uint32_t keyboard)
    {
        wl_resource* keyboard_resolved{
            wl_resource_create(client, &wl_keyboard_interface_data, wl_resource_get_version(resource), keyboard)};
        if (keyboard_resolved == nullptr)
        {
            wl_client_post_no_memory(client);
            BOOST_THROW_EXCEPTION((std::bad_alloc{}));
        }
        try
        {
            auto me = static_cast<InputMethodContextV1*>(wl_resource_get_user_data(resource));
            me->grab_keyboard(keyboard_resolved);
        }
        catch(ProtocolError const& err)
        {
            wl_resource_post_error(err.resource(), err.code(), "%s", err.message());
        }
        catch(...)
        {
            internal_error_processing_request(client, "InputMethodContextV1::grab_keyboard()");
        }
    }

    static void key_thunk(struct wl_client* client, struct wl_resource* resource, uint32_t serial, uint32_t time, uint32_t key, uint32_t state)
    {
        try
        {
            auto me = static_cast<InputMethodContextV1*>(wl_resource_get_user_data(resource));
            me->key(serial, time, key, state);
        }
        catch(ProtocolError const& err)
        {
            wl_resource_post_error(err.resource(), err.code(), "%s", err.message());
        }
        catch(...)
        {
            internal_error_processing_request(client, "InputMethodContextV1::key()");
        }
    }

    static void modifiers_thunk(struct wl_client* client, struct wl_resource* resource, uint32_t serial, uint32_t mods_depressed, uint32_t mods_latched, uint32_t mods_locked, uint32_t group)
    {
        try
        {
            auto me = static_cast<InputMethodContextV1*>(wl_resource_get_user_data(resource));
            me->modifiers(serial, mods_depressed, mods_latched, mods_locked, group);
        }
        catch(ProtocolError const& err)
        {
            wl_resource_post_error(err.resource(), err.code(), "%s", err.message());
        }
        catch(...)
        {
            internal_error_processing_request(client, "InputMethodContextV1::modifiers()");
        }
    }

    static void language_thunk(struct wl_client* client, struct wl_resource* resource, uint32_t serial, char const* language)
    {
        try
        {
            auto me = static_cast<InputMethodContextV1*>(wl_resource_get_user_data(resource));
            me->language(serial, language);
        }
        catch(ProtocolError const& err)
        {
            wl_resource_post_error(err.resource(), err.code(), "%s", err.message());
        }
        catch(...)
        {
            internal_error_processing_request(client, "InputMethodContextV1::language()");
        }
    }

    static void text_direction_thunk(struct wl_client* client, struct wl_resource* resource, uint32_t serial, uint32_t direction)
    {
        try
        {
            auto me = static_cast<InputMethodContextV1*>(wl_resource_get_user_data(resource));
            me->text_direction(serial, direction);
        }
        catch(ProtocolError const& err)
        {
            wl_resource_post_error(err.resource(), err.code(), "%s", err.message());
        }
        catch(...)
        {
            internal_error_processing_request(client, "InputMethodContextV1::text_direction()");
        }
    }

    static void resource_destroyed_thunk(wl_resource* resource)
    {
        delete static_cast<InputMethodContextV1*>(wl_resource_get_user_data(resource));
    }

    static struct wl_interface const* grab_keyboard_types[];
    static struct wl_message const request_messages[];
    static struct wl_message const event_messages[];
    static void const* request_vtable[];
};

int const mw::InputMethodContextV1::Thunks::supported_version = 1;

mw::InputMethodContextV1::InputMethodContextV1(InputMethodV1 const& parent)
    : Resource{wl_resource_create(
          wl_resource_get_client(parent.resource),
          &zwp_input_method_context_v1_interface_data,
          wl_resource_get_version(parent.resource), 0)}
{
    wl_resource_set_implementation(resource, Thunks::request_vtable, this, &Thunks::resource_destroyed_thunk);
}

mw::InputMethodContextV1::~InputMethodContextV1()
{
    wl_resource_set_implementation(resource, nullptr, nullptr, nullptr);
}

void mw::InputMethodContextV1::send_surrounding_text_event(std::string const& text, uint32_t cursor, uint32_t anchor) const
{
    const char* text_resolved = text.c_str();
    wl_resource_post_event(resource, Opcode::surrounding_text, text_resolved, cursor, anchor);
}

void mw::InputMethodContextV1::send_reset_event() const
{
    wl_resource_post_event(resource, Opcode::reset);
}

void mw::InputMethodContextV1::send_content_type_event(uint32_t hint, uint32_t purpose) const
{
    wl_resource_post_event(resource, Opcode::content_type, hint, purpose);
}

void mw::InputMethodContextV1::send_invoke_action_event(uint32_t button, uint32_t index) const
{
    wl_resource_post_event(resource, Opcode::invoke_action, button, index);
}

void mw::InputMethodContextV1::send_commit_state_event(uint32_t serial) const
{
    wl_resource_post_event(resource, Opcode::commit_state, serial);
}

void mw::InputMethodContextV1::send_preferred_language_event(std::string const& language) const
{
    const char* language_resolved = language.c_str();
    wl_resource_post_event(resource, Opcode::preferred_language, language_resolved);
}

bool mw::InputMethodContextV1::is_instance(wl_resource* resource)
{
    return wl_resource_instance_of(resource, &zwp_input_method_context_v1_interface_data, Thunks::request_vtable);
}

struct wl_interface const* mw::InputMethodContextV1::Thunks::grab_keyboard_types[] {
    &wl_keyboard_interface_data};

struct wl_message const mw::InputMethodContextV1::Thunks::request_messages[] {
    {"destroy", "", all_null_types},
    {"commit_string", "us", all_null_types},
    {"preedit_string", "uss", all_null_types},
    {"preedit_styling", "uuu", all_null_types},
    {"preedit_cursor", "i", all_null_types},
    {"delete_surrounding_text", "iu", all_null_types},
    {"cursor_position", "ii", all_null_types},
    {"modifiers_map", "a", all_null_types},
    {"keysym", "uuuuu", all_null_types},
    {"grab_keyboard", "n", grab_keyboard_types},
    {"key", "uuuu", all_null_types},
    {"modifiers", "uuuuu", all_null_types},
    {"language", "us", all_null_types},
    {"text_direction", "uu", all_null_types}};

struct wl_message const mw::InputMethodContextV1::Thunks::event_messages[] {
    {"surrounding_text", "suu", all_null_types},
    {"reset", "", all_null_types},
    {"content_type", "uu", all_null_types},
    {"invoke_action", "uu", all_null_types},
    {"commit_state", "u", all_null_types},
    {"preferred_language", "s", all_null_types}};

void const* mw::InputMethodContextV1::Thunks::request_vtable[] {
    (void*)Thunks::destroy_thunk,
    (void*)Thunks::commit_string_thunk,
    (void*)Thunks::preedit_string_thunk,
    (void*)Thunks::preedit_styling_thunk,
    (void*)Thunks::preedit_cursor_thunk,
    (void*)Thunks::delete_surrounding_text_thunk,
    (void*)Thunks::cursor_position_thunk,
    (void*)Thunks::modifiers_map_thunk,
    (void*)Thunks::keysym_thunk,
    (void*)Thunks::grab_keyboard_thunk,
    (void*)Thunks::key_thunk,
    (void*)Thunks::modifiers_thunk,
    (void*)Thunks::language_thunk,
    (void*)Thunks::text_direction_thunk};

mw::InputMethodContextV1* mw::InputMethodContextV1::from(struct wl_resource* resource)
{
    if (resource &&
        wl_resource_instance_of(resource, &zwp_input_method_context_v1_interface_data, InputMethodContextV1::Thunks::request_vtable))
    {
        return static_cast<InputMethodContextV1*>(wl_resource_get_user_data(resource));
    }
    else
    {
        return nullptr;
    }
}

// InputMethodV1

struct mw::InputMethodV1::Thunks
{
    static int const supported_version;

    static void resource_destroyed_thunk(wl_resource* resource)
    {
        delete static_cast<InputMethodV1*>(wl_resource_get_user_data(resource));
    }

    static void bind_thunk(struct wl_client* client, void* data, uint32_t version, uint32_t id)
    {
        auto me = static_cast<InputMethodV1::Global*>(data);
        auto resource = wl_resource_create(
            client,
            &zwp_input_method_v1_interface_data,
            std::min((int)version, Thunks::supported_version),
            id);
        if (resource == nullptr)
        {
            wl_client_post_no_memory(client);
            BOOST_THROW_EXCEPTION((std::bad_alloc{}));
        }
        try
        {
            me->bind(resource);
        }
        catch(...)
        {
            internal_error_processing_request(client, "InputMethodV1 global bind");
        }
    }

    static struct wl_interface const* activate_types[];
    static struct wl_interface const* deactivate_types[];
    static struct wl_message const event_messages[];
    static void const* request_vtable[];
};

int const mw::InputMethodV1::Thunks::supported_version = 1;

mw::InputMethodV1::InputMethodV1(struct wl_resource* resource, Version<1>)
    : Resource{resource}
{
    wl_resource_set_implementation(resource, Thunks::request_vtable, this, &Thunks::resource_destroyed_thunk);
}

mw::InputMethodV1::~InputMethodV1()
{
    wl_resource_set_implementation(resource, nullptr, nullptr, nullptr);
}

void mw::InputMethodV1::send_activate_event(struct wl_resource* id) const
{
    wl_resource_post_event(resource, Opcode::activate, id);
}

void mw::InputMethodV1::send_deactivate_event(struct wl_resource* context) const
{
    wl_resource_post_event(resource, Opcode::deactivate, context);
}

bool mw::InputMethodV1::is_instance(wl_resource* resource)
{
    return wl_resource_instance_of(resource, &zwp_input_method_v1_interface_data, Thunks::request_vtable);
}

void mw::InputMethodV1::destroy_and_delete() const
{
    // Will result in this object being deleted
    wl_resource_destroy(resource);
}

mw::InputMethodV1::Global::Global(wl_display* display, Version<1>)
    : wayland::Global{
          wl_global_create(
              display,
              &zwp_input_method_v1_interface_data,
              Thunks::supported_version,
              this,
              &Thunks::bind_thunk)}
{
}

auto mw::InputMethodV1::Global::interface_name() const -> char const*
{
    return InputMethodV1::interface_name;
}

struct wl_interface const* mw::InputMethodV1::Thunks::activate_types[] {
    &zwp_input_method_context_v1_interface_data};

struct wl_interface const* mw::InputMethodV1::Thunks::deactivate_types[] {
    &zwp_input_method_context_v1_interface_data};

struct wl_message const mw::InputMethodV1::Thunks::event_messages[] {
    {"activate", "n", activate_types},
    {"deactivate", "o", deactivate_types}};

void const* mw::InputMethodV1::Thunks::request_vtable[] {
    nullptr};

mw::InputMethodV1* mw::InputMethodV1::from(struct wl_resource* resource)
{
    if (resource &&
        wl_resource_instance_of(resource, &zwp_input_method_v1_interface_data, InputMethodV1::Thunks::request_vtable))
    {
        return static_cast<InputMethodV1*>(wl_resource_get_user_data(resource));
    }
    else
    {
        return nullptr;
    }
}

// InputPanelV1

struct mw::InputPanelV1::Thunks
{
    static int const supported_version;

    static void get_input_panel_surface_thunk(struct wl_client* client, struct wl_resource* resource, uint32_t id, struct wl_resource* surface)
    {
        wl_resource* id_resolved{
            wl_resource_create(client, &zwp_input_panel_surface_v1_interface_data, wl_resource_get_version(resource), id)};
        if (id_resolved == nullptr)
        {
            wl_client_post_no_memory(client);
            BOOST_THROW_EXCEPTION((std::bad_alloc{}));
        }
        try
        {
            auto me = static_cast<InputPanelV1*>(wl_resource_get_user_data(resource));
            me->get_input_panel_surface(id_resolved, surface);
        }
        catch(ProtocolError const& err)
        {
            wl_resource_post_error(err.resource(), err.code(), "%s", err.message());
        }
        catch(...)
        {
            internal_error_processing_request(client, "InputPanelV1::get_input_panel_surface()");
        }
    }

    static void resource_destroyed_thunk(wl_resource* resource)
    {
        delete static_cast<InputPanelV1*>(wl_resource_get_user_data(resource));
    }

    static void bind_thunk(struct wl_client* client, void* data, uint32_t version, uint32_t id)
    {
        auto me = static_cast<InputPanelV1::Global*>(data);
        auto resource = wl_resource_create(
            client,
            &zwp_input_panel_v1_interface_data,
            std::min((int)version, Thunks::supported_version),
            id);
        if (resource == nullptr)
        {
            wl_client_post_no_memory(client);
            BOOST_THROW_EXCEPTION((std::bad_alloc{}));
        }
        try
        {
            me->bind(resource);
        }
        catch(...)
        {
            internal_error_processing_request(client, "InputPanelV1 global bind");
        }
    }

    static struct wl_interface const* get_input_panel_surface_types[];
    static struct wl_message const request_messages[];
    static void const* request_vtable[];
};

int const mw::InputPanelV1::Thunks::supported_version = 1;

mw::InputPanelV1::InputPanelV1(struct wl_resource* resource, Version<1>)
    : Resource{resource}
{
    wl_resource_set_implementation(resource, Thunks::request_vtable, this, &Thunks::resource_destroyed_thunk);
}

mw::InputPanelV1::~InputPanelV1()
{
    wl_resource_set_implementation(resource, nullptr, nullptr, nullptr);
}

bool mw::InputPanelV1::is_instance(wl_resource* resource)
{
    return wl_resource_instance_of(resource, &zwp_input_panel_v1_interface_data, Thunks::request_vtable);
}

void mw::InputPanelV1::destroy_and_delete() const
{
    // Will result in this object being deleted
    wl_resource_destroy(resource);
}

mw::InputPanelV1::Global::Global(wl_display* display, Version<1>)
    : wayland::Global{
          wl_global_create(
              display,
              &zwp_input_panel_v1_interface_data,
              Thunks::supported_version,
              this,
              &Thunks::bind_thunk)}
{
}

auto mw::InputPanelV1::Global::interface_name() const -> char const*
{
    return InputPanelV1::interface_name;
}

struct wl_interface const* mw::InputPanelV1::Thunks::get_input_panel_surface_types[] {
    &zwp_input_panel_surface_v1_interface_data,
    &wl_surface_interface_data};

struct wl_message const mw::InputPanelV1::Thunks::request_messages[] {
    {"get_input_panel_surface", "no", get_input_panel_surface_types}};

void const* mw::InputPanelV1::Thunks::request_vtable[] {
    (void*)Thunks::get_input_panel_surface_thunk};

mw::InputPanelV1* mw::InputPanelV1::from(struct wl_resource* resource)
{
    if (resource &&
        wl_resource_instance_of(resource, &zwp_input_panel_v1_interface_data, InputPanelV1::Thunks::request_vtable))
    {
        return static_cast<InputPanelV1*>(wl_resource_get_user_data(resource));
    }
    else
    {
        return nullptr;
    }
}

// InputPanelSurfaceV1

struct mw::InputPanelSurfaceV1::Thunks
{
    static int const supported_version;

    static void set_toplevel_thunk(struct wl_client* client, struct wl_resource* resource, struct wl_resource* output, uint32_t position)
    {
        try
        {
            auto me = static_cast<InputPanelSurfaceV1*>(wl_resource_get_user_data(resource));
            me->set_toplevel(output, position);
        }
        catch(ProtocolError const& err)
        {
            wl_resource_post_error(err.resource(), err.code(), "%s", err.message());
        }
        catch(...)
        {
            internal_error_processing_request(client, "InputPanelSurfaceV1::set_toplevel()");
        }
    }

    static void set_overlay_panel_thunk(struct wl_client* client, struct wl_resource* resource)
    {
        try
        {
            auto me = static_cast<InputPanelSurfaceV1*>(wl_resource_get_user_data(resource));
            me->set_overlay_panel();
        }
        catch(ProtocolError const& err)
        {
            wl_resource_post_error(err.resource(), err.code(), "%s", err.message());
        }
        catch(...)
        {
            internal_error_processing_request(client, "InputPanelSurfaceV1::set_overlay_panel()");
        }
    }

    static void resource_destroyed_thunk(wl_resource* resource)
    {
        delete static_cast<InputPanelSurfaceV1*>(wl_resource_get_user_data(resource));
    }

    static struct wl_interface const* set_toplevel_types[];
    static struct wl_message const request_messages[];
    static void const* request_vtable[];
};

int const mw::InputPanelSurfaceV1::Thunks::supported_version = 1;

mw::InputPanelSurfaceV1::InputPanelSurfaceV1(struct wl_resource* resource, Version<1>)
    : Resource{resource}
{
    wl_resource_set_implementation(resource, Thunks::request_vtable, this, &Thunks::resource_destroyed_thunk);
}

mw::InputPanelSurfaceV1::~InputPanelSurfaceV1()
{
    wl_resource_set_implementation(resource, nullptr, nullptr, nullptr);
}

bool mw::InputPanelSurfaceV1::is_instance(wl_resource* resource)
{
    return wl_resource_instance_of(resource, &zwp_input_panel_surface_v1_interface_data, Thunks::request_vtable);
}

void mw::InputPanelSurfaceV1::destroy_and_delete() const
{
    // Will result in this object being deleted
    wl_resource_destroy(resource);
}

uint32_t const mw::InputPanelSurfaceV1::Position::center_bottom;

struct wl_interface const* mw::InputPanelSurfaceV1::Thunks::set_toplevel_types[] {
    &wl_output_interface_data,
    nullptr};

struct wl_message const mw::InputPanelSurfaceV1::Thunks::request_messages[] {
    {"set_toplevel", "ou", set_toplevel_types},
    {"set_overlay_panel", "", all_null_types}};

void const* mw::InputPanelSurfaceV1::Thunks::request_vtable[] {
    (void*)Thunks::set_toplevel_thunk,
    (void*)Thunks::set_overlay_panel_thunk};

mw::InputPanelSurfaceV1* mw::InputPanelSurfaceV1::from(struct wl_resource* resource)
{
    if (resource &&
        wl_resource_instance_of(resource, &zwp_input_panel_surface_v1_interface_data, InputPanelSurfaceV1::Thunks::request_vtable))
    {
        return static_cast<InputPanelSurfaceV1*>(wl_resource_get_user_data(resource));
    }
    else
    {
        return nullptr;
    }
}

namespace mir
{
namespace wayland
{

struct wl_interface const zwp_input_method_context_v1_interface_data {
    mw::InputMethodContextV1::interface_name,
    mw::InputMethodContextV1::Thunks::supported_version,
    14, mw::InputMethodContextV1::Thunks::request_messages,
    6, mw::InputMethodContextV1::Thunks::event_messages};

struct wl_interface const zwp_input_method_v1_interface_data {
    mw::InputMethodV1::interface_name,
    mw::InputMethodV1::Thunks::supported_version,
    0, nullptr,
    2, mw::InputMethodV1::Thunks::event_messages};

struct wl_interface const zwp_input_panel_v1_interface_data {
    mw::InputPanelV1::interface_name,
    mw::InputPanelV1::Thunks::supported_version,
    1, mw::InputPanelV1::Thunks::request_messages,
    0, nullptr};

struct wl_interface const zwp_input_panel_surface_v1_interface_data {
    mw::InputPanelSurfaceV1::interface_name,
    mw::InputPanelSurfaceV1::Thunks::supported_version,
    2, mw::InputPanelSurfaceV1::Thunks::request_messages,
    0, nullptr};

}
}
